;==============================================================================
; bootloader sample 01 for CODEGATE 2011 
;==============================================================================
; Author    somma (somma@fsksec.co.kr)
;           http://somma.egloos.com
;==============================================================================
; All rights reserved by FSK Security Co.Ltd.
;==============================================================================

ORG 0
BITS 16
CPU 486

jmp 0x07c0:bootsector_entry           ; now cs = 0x07c0

welcome     db      'welcome to CODEGATE 2011 training course!!',13,10,0

;==============================================================================
; bootsector_entry
;==============================================================================
bootsector_entry:
	mov		ax, 0x07c0
	mov		ds, ax

    ; clear screen
    ;
    mov ax, 0x0003
    int 0x10
    
    mov     si, welcome
	
	.write_msg: 
        lodsb                   ; load byte at ds:si into al
        or  al,al                ; test if character is 0 (end)
        jz  .done
        mov ah,0eh              ; put character
        mov bx,0007             ; attribute
        int 0x10                ; call BIOS
        jmp .write_msg
		.done:
			nop
    
    ; hmm... what's next ???
    ;
    hlt    

;#############################
;##  Boot Sector Signature  ##
;#############################

    times   510-($-$$)    db 0	
	dw      0AA55h
